| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
cv::SIFT Class Referenceabstract
Features Framework » Feature Detection and Description

Class for extracting keypoints and computing descriptors using the Scale Invariant Feature Transform (SIFT) algorithm by D. Lowe [174] . More...

`#include <opencv2/features.hpp>`

Collaboration diagram for cv::SIFT:

## Public Member Functions
virtual double | getContrastThreshold () const =0
virtual String | getDefaultName () const CV_OVERRIDE
virtual double | getEdgeThreshold () const =0
virtual int | getNFeatures () const =0
virtual int | getNOctaveLayers () const =0
virtual double | getSigma () const =0
virtual void | setContrastThreshold (double contrastThreshold)=0
virtual void | setEdgeThreshold (double edgeThreshold)=0
virtual void | setNFeatures (int maxFeatures)=0
virtual void | setNOctaveLayers (int nOctaveLayers)=0
virtual void | setSigma (double sigma)=0
Public Member Functions inherited from cv::Feature2D
virtual | ~Feature2D ()
virtual void | compute (InputArray image, std::vector< KeyPoint > &keypoints, OutputArray descriptors)
| Computes the descriptors for a set of keypoints detected in an image (first variant) or image set (second variant).
virtual void | compute (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, OutputArrayOfArrays descriptors)
virtual int | defaultNorm () const
virtual int | descriptorSize () const
virtual int | descriptorType () const
virtual void | detect (InputArray image, std::vector< KeyPoint > &keypoints, InputArray mask=noArray())
| Detects keypoints in an image (first variant) or image set (second variant).
virtual void | detect (InputArrayOfArrays images, std::vector< std::vector< KeyPoint > > &keypoints, InputArrayOfArrays masks=noArray())
virtual void | detectAndCompute (InputArray image, InputArray mask, std::vector< KeyPoint > &keypoints, OutputArray descriptors, bool useProvidedKeypoints=false)
virtual bool | empty () const CV_OVERRIDE
| Return true if detector object is empty.
virtual void | read (const FileNode &) CV_OVERRIDE
| Reads algorithm parameters from a file storage.
void | read (const String &fileName)
void | write (const String &fileName) const
virtual void | write (FileStorage &) const CV_OVERRIDE
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const
Public Member Functions inherited from cv::Algorithm
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual void | save (const String &filename) const
void | write (FileStorage &fs, const String &name) const

## Static Public Member Functions
static Ptr< SIFT > | create (int nfeatures, int nOctaveLayers, double contrastThreshold, double edgeThreshold, double sigma, int descriptorType, bool enable_precise_upscale=false)
| Create SIFT with specified descriptorType.
static Ptr< SIFT > | create (int nfeatures=0, int nOctaveLayers=3, double contrastThreshold=0.04, double edgeThreshold=10, double sigma=1.6, bool enable_precise_upscale=false)
Static Public Member Functions inherited from cv::Algorithm
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.

## Additional Inherited Members
Protected Member Functions inherited from cv::Algorithm
void | writeFormat (FileStorage &fs) const

## Detailed Description

Class for extracting keypoints and computing descriptors using the Scale Invariant Feature Transform (SIFT) algorithm by D. Lowe [174] .

## Member Function Documentation

## ◆ create() [1/2]

static Ptr< SIFT > cv::SIFT::create | ( | int | nfeatures,
|  | int | nOctaveLayers,
|  | double | contrastThreshold,
|  | double | edgeThreshold,
|  | double | sigma,
|  | int | descriptorType,
|  | bool | enable_precise_upscale = false )
| static

Python:
| cv.SIFT.create( | [, nfeatures[, nOctaveLayers[, contrastThreshold[, edgeThreshold[, sigma[, enable_precise_upscale]]]]]] | ) -> | retval
| cv.SIFT.create( | nfeatures, nOctaveLayers, contrastThreshold, edgeThreshold, sigma, descriptorType[, enable_precise_upscale] | ) -> | retval
| cv.SIFT_create( | [, nfeatures[, nOctaveLayers[, contrastThreshold[, edgeThreshold[, sigma[, enable_precise_upscale]]]]]] | ) -> | retval
| cv.SIFT_create( | nfeatures, nOctaveLayers, contrastThreshold, edgeThreshold, sigma, descriptorType[, enable_precise_upscale] | ) -> | retval

Create SIFT with specified descriptorType.

Parameters

  nfeatures | The number of best features to retain. The features are ranked by their scores (measured in SIFT algorithm as the local contrast)
  nOctaveLayers | The number of layers in each octave. 3 is the value used in D. Lowe paper. The number of octaves is computed automatically from the image resolution.
  contrastThreshold | The contrast threshold used to filter out weak features in semi-uniform (low-contrast) regions. The larger the threshold, the less features are produced by the detector.

Note
  The contrast threshold will be divided by nOctaveLayers when the filtering is applied. When nOctaveLayers is set to default and if you want to use the value used in D. Lowe paper, 0.03, set this argument to 0.09.

Parameters

  edgeThreshold | The threshold used to filter out edge-like features. Note that the its meaning is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained).
  sigma | The sigma of the Gaussian applied to the input image at the octave #0. If your image is captured with a weak camera with soft lenses, you might want to reduce the number.
  descriptorType | The type of descriptors. Only CV_32F and CV_8U are supported.
  enable_precise_upscale | Whether to enable precise upscaling in the scale pyramid, which maps index \(\texttt{x}\) to \(\texttt{2x}\). This prevents localization bias. The option is disabled by default.

## ◆ create() [2/2]

static Ptr< SIFT > cv::SIFT::create | ( | int | nfeatures = 0,
|  | int | nOctaveLayers = 3,
|  | double | contrastThreshold = 0.04,
|  | double | edgeThreshold = 10,
|  | double | sigma = 1.6,
|  | bool | enable_precise_upscale = false )
| static

Python:
| cv.SIFT.create( | [, nfeatures[, nOctaveLayers[, contrastThreshold[, edgeThreshold[, sigma[, enable_precise_upscale]]]]]] | ) -> | retval
| cv.SIFT.create( | nfeatures, nOctaveLayers, contrastThreshold, edgeThreshold, sigma, descriptorType[, enable_precise_upscale] | ) -> | retval
| cv.SIFT_create( | [, nfeatures[, nOctaveLayers[, contrastThreshold[, edgeThreshold[, sigma[, enable_precise_upscale]]]]]] | ) -> | retval
| cv.SIFT_create( | nfeatures, nOctaveLayers, contrastThreshold, edgeThreshold, sigma, descriptorType[, enable_precise_upscale] | ) -> | retval

Parameters

  nfeatures | The number of best features to retain. The features are ranked by their scores (measured in SIFT algorithm as the local contrast)
  nOctaveLayers | The number of layers in each octave. 3 is the value used in D. Lowe paper. The number of octaves is computed automatically from the image resolution.
  contrastThreshold | The contrast threshold used to filter out weak features in semi-uniform (low-contrast) regions. The larger the threshold, the less features are produced by the detector.

Note
  The contrast threshold will be divided by nOctaveLayers when the filtering is applied. When nOctaveLayers is set to default and if you want to use the value used in D. Lowe paper, 0.03, set this argument to 0.09.

Parameters

  edgeThreshold | The threshold used to filter out edge-like features. Note that the its meaning is different from the contrastThreshold, i.e. the larger the edgeThreshold, the less features are filtered out (more features are retained).
  sigma | The sigma of the Gaussian applied to the input image at the octave #0. If your image is captured with a weak camera with soft lenses, you might want to reduce the number.
  enable_precise_upscale | Whether to enable precise upscaling in the scale pyramid, which maps index \(\texttt{x}\) to \(\texttt{2x}\). This prevents localization bias. The option is disabled by default.

## ◆ getContrastThreshold()

virtual double cv::SIFT::getContrastThreshold | ( |  | ) | const
| pure virtual

Python:
| cv.SIFT.getContrastThreshold( |  | ) -> | retval

## ◆ getDefaultName()

virtual String cv::SIFT::getDefaultName | ( |  | ) | const
| virtual

Python:
| cv.SIFT.getDefaultName( |  | ) -> | retval

Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.

Reimplemented from cv::Feature2D.

## ◆ getEdgeThreshold()

virtual double cv::SIFT::getEdgeThreshold | ( |  | ) | const
| pure virtual

Python:
| cv.SIFT.getEdgeThreshold( |  | ) -> | retval

## ◆ getNFeatures()

virtual int cv::SIFT::getNFeatures | ( |  | ) | const
| pure virtual

Python:
| cv.SIFT.getNFeatures( |  | ) -> | retval

## ◆ getNOctaveLayers()

virtual int cv::SIFT::getNOctaveLayers | ( |  | ) | const
| pure virtual

Python:
| cv.SIFT.getNOctaveLayers( |  | ) -> | retval

## ◆ getSigma()

virtual double cv::SIFT::getSigma | ( |  | ) | const
| pure virtual

Python:
| cv.SIFT.getSigma( |  | ) -> | retval

## ◆ setContrastThreshold()

virtual void cv::SIFT::setContrastThreshold | ( | double | contrastThreshold | ) |
| pure virtual

Python:
| cv.SIFT.setContrastThreshold( | contrastThreshold | ) -> | None

## ◆ setEdgeThreshold()

virtual void cv::SIFT::setEdgeThreshold | ( | double | edgeThreshold | ) |
| pure virtual

Python:
| cv.SIFT.setEdgeThreshold( | edgeThreshold | ) -> | None

## ◆ setNFeatures()

virtual void cv::SIFT::setNFeatures | ( | int | maxFeatures | ) |
| pure virtual

Python:
| cv.SIFT.setNFeatures( | maxFeatures | ) -> | None

## ◆ setNOctaveLayers()

virtual void cv::SIFT::setNOctaveLayers | ( | int | nOctaveLayers | ) |
| pure virtual

Python:
| cv.SIFT.setNOctaveLayers( | nOctaveLayers | ) -> | None

## ◆ setSigma()

virtual void cv::SIFT::setSigma | ( | double | sigma | ) |
| pure virtual

Python:
| cv.SIFT.setSigma( | sigma | ) -> | None

The documentation for this class was generated from the following file:

- opencv2/features.hpp